//Vlad Tudose 100 puncte
#include<cstdio>
#define Km 5001
#define abs(a) ((a)<0?-(a):(a))
#define lg (A[i].a<A[i].b?A[i].b-A[i].a+1:A[i].a-A[i].b+1)
#define sign (A[i].a<A[i].b?1:-1)
#define ll long long
using namespace std;
int n,na,nb;
struct
{
	int a,b;
} X[Km<<1],Y[Km<<1],*A,*B,*aux;

inline void swap(int &a, int &b) { a=a^b, b=a^b, a=a^b; }

void update(int st, int dr)
{
	int i,j=0,p1,p2;

	nb=0;
	for(i=0;j+lg<st;++i)
		B[nb++]=A[i], j+=lg;
	if(j+1<st)
		B[nb].a=A[i].a, B[nb++].b=A[i].a+(st-j-2)*sign;

	if(dr<=j+lg)
	{
		B[nb].b=A[i].a+(st-j-1)*sign;
		B[nb++].a=A[i].a+(dr-j-1)*sign;
		if(dr<j+lg)
			B[nb].a=B[nb-1].a+sign,
			B[nb++].b=A[i].b;
		++i;
	}
	else
	{
		p1=nb;
		B[nb].a=A[i].a+(st-j-1)*sign;
		B[nb++].b=A[i].b;
		j+=lg;

		for(++i;i<na && j+lg<=dr;++i)
			B[nb++]=A[i], j+=lg;
		if(j==dr)
			p2=nb-1;
		else
		{
			p2=nb;
			B[nb].a=A[i].a;
			B[nb++].b=A[i].a+(dr-j-1)*sign;
			B[nb].a=B[nb-1].b+sign;
			B[nb++].b=A[i].b;
			++i;
		}

		while(p1<p2)
		{
			swap(B[p1].a,B[p2].b);
			swap(B[p1].b,B[p2].a);
			++p1; --p2;
		}
		if(p1==p2)
			swap(B[p1].a,B[p1].b);
	}

	for(;i<na;++i)
		B[nb++]=A[i];
	na=nb;
	aux=A; A=B; B=aux;
}

inline ll sum(int a, int b)
{
	if(a>b) swap(a,b);
	return ((ll)b*(b+1)-(ll)a*(a-1))>>1;
}

ll query(int st, int dr)
{
	int i,j=0;
	ll ans=(ll)n*(n+1)/2;

	for(i=0;j+lg<st;++i)
		ans-=sum(A[i].a,A[i].b), j+=lg;
	if(j+1<st)
		ans-=sum(A[i].a,A[i].a+(st-j-2)*sign);

	j=n;
	for(i=na-1;j-lg>=dr;--i)
		ans-=sum(A[i].a,A[i].b), j-=lg;
	if(dr<j)
		ans-=sum(A[i].b,A[i].b-(j-dr-1)*sign);
	return ans;
}

int main()
{
	char t;
	int k,st,dr;

	freopen("secvop.in","r",stdin);
	freopen("secvop.out","w",stdout);

	scanf("%d%d",&n,&k);
	A=X; B=Y; na=1; A[0].a=1; A[0].b=n;

	while(k--)
	{
		scanf(" %c%d%d",&t,&st,&dr);
		if(t=='I')
			update(st,dr);
		if(t=='S')
			printf("%lld\n",query(st,dr));
	}
	return 0;
}
